#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define MAX_ITENS    200

#define TAM_ARQNOME  128
#define TAM_NOME      41
#define TAM_END      121
#define TAM_FONE      16
#define TAM_EMAIL     21
#define TAM_CIDADE    11
#define TAM_CEP       10
#define TAM_ESTADO     4
#define TAM_NIVER     10

struct endereco {
  char nome[TAM_NOME];
  char end[TAM_END];
  char fone[TAM_FONE];
  char email[TAM_EMAIL];
  char cidade[TAM_CIDADE];
  char cep[TAM_CEP];
  char estado[TAM_ESTADO];
  char niver[TAM_NIVER];
};

void imprimeItem (struct endereco item)
{
    printf("NOME: %s\n", item.nome);
    printf("ENDERECO: %s\n", item.end);
    printf("FONE: %s\n", item.fone);
    printf("E-MAIL: %s\n", item.email);
    printf("CIDADE: %s\n", item.cidade);
    printf("ESTADO: %s\n", item.estado);
    printf("CEP: %s\n", item.cep);
    printf("-----------------------\n");
}


void imprimeAgenda(struct endereco agenda[])
{
  int i;

  printf("\n\n=====================\n\n");

  for (i=0; strlen(agenda[i].nome); i++)
    imprimeItem(agenda[i]);

  printf("\n\n");
}



int main ()
{

  struct endereco agenda[MAX_ITENS],
                  ragenda[MAX_ITENS];
  char arquivo[] = "agenda.dat";
  int nitens;
  FILE *fp;
  struct stat arqstat;

  fp = fopen (arquivo, "r");
  
  if (fp == NULL)
    printf("Erro ao abrir arquivo %s\n", arquivo);
  else {
    printf("\n\nLendo agenda do arquivo \"%s\" ....\n\n ", arquivo);
    
    /* lendo ate que o arquivo acabe */
    stat(arquivo, &arqstat);
    
    nitens = arqstat.st_size;
    
    if (fread(ragenda,sizeof(char), nitens, fp) == nitens)
      imprimeAgenda(ragenda);
    else
      printf("Erro na leitura do arquivo %s\n", arquivo);
    
    fclose(fp);     /* fecha arquivo */
  }  /* FIM (fp == NULL) */
}

